
import org.junit.Assert;
import org.junit.Test;

import java.util.List;

import static org.junit.Assert.*;

public class MyArrayListTest {


    public MyArrayListTest() {
    }

    @Test
    public void addTest(){
        //Given
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(5);

        //When
        int expected = 1;
        int actual = myArrayList.size();

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void addTest2(){
        //Given
        MyArrayList<String> myArrayList = new MyArrayList<>();
        myArrayList.add("Hi");
        myArrayList.add("Mars");

        //When
        int expected = 2;
        int actual = myArrayList.size();

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void addTest3(){
        //Given
        MyArrayList<Object> myArrayList = new MyArrayList<>();
        myArrayList.add(509);

        //When
        int expected = 1;
        int actual = myArrayList.size();

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void addTest4(){
        //Given
        MyArrayList<Long> myArrayList = new MyArrayList<>();
        myArrayList.add(878070L);

        //When
        int expected = 1;
        int actual = myArrayList.size();

        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void removeTest(){
        //Given
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(5);
        myArrayList.add(15);
        myArrayList.remove(5);
        //When
        int expected = 1;
        int actual = myArrayList.size();
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void removeTest2(){
        //Given
        MyArrayList<String> myArrayList = new MyArrayList<>();
        myArrayList.add("Hi");
        myArrayList.add("Mars");
        myArrayList.remove("Mars");
        //When
        int expected = 1;
        int actual = myArrayList.size();
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void removeTest3(){
        //Given
        MyArrayList<Object> myArrayList = new MyArrayList<>();
        myArrayList.add(5);
        myArrayList.add("Hi");
        myArrayList.remove(5);
        //When
        int expected = 1;
        int actual = myArrayList.size();
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getTest(){
        //Given
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(6);
        myArrayList.add(12);
        //When
        Integer expected = 6;
        Integer actual = myArrayList.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getTest2(){
        //Given
        MyArrayList<String> myArrayList = new MyArrayList<>();
        myArrayList.add("Hi");
        myArrayList.add("Mars");
        //When
        String expected = "Hi";
        String actual = myArrayList.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getTest3(){
        //Given
        MyArrayList<Object> myArrayList = new MyArrayList<>();
        myArrayList.add(6);
        myArrayList.add("Hi");
        //When
        Object expected = 6;
        Object actual = myArrayList.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getTest4(){
        //Given
        MyArrayList<Long> myArrayList = new MyArrayList<>();
        myArrayList.add(6L);
        myArrayList.add(1200L);
        //When
        Long expected = 1200L;
        Long actual = myArrayList.get(1);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest(){
        //Given
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(45);
        myArrayList.add(12);
        myArrayList.set(0, 6);
        //When
        int expected = 6;
        int actual = myArrayList.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest2(){
        //Given
        MyArrayList<String> myArrayList = new MyArrayList<>();
        myArrayList.add("Hi");
        myArrayList.add("Mars");
        myArrayList.set(0, "Bye");
        //When
        String expected = "Bye";
        String actual = myArrayList.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest3(){
        //Given
        MyArrayList<Object> myArrayList = new MyArrayList<>();
        myArrayList.add(45);
        myArrayList.add("Hi");
        myArrayList.set(0, 6);
        //When
        Object expected = 6;
        Object actual = myArrayList.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest4(){
        //Given
        MyArrayList<Long> myArrayList = new MyArrayList<>();
        myArrayList.add(45L);
        myArrayList.add(1200L);
        myArrayList.set(0, 6L);
        //When
        Long expected = 6L;
        Long actual = myArrayList.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }


    @Test
    public void clearTest(){
        //Given
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(45);
        myArrayList.add(12);
        myArrayList.clear();
        //When

        //Then
        Assert.assertTrue(myArrayList.isEmpty());
    }

    @Test
    public void isEmptyTest(){
        //Given
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(45);
        myArrayList.add(12);
        //When

        //Then
        Assert.assertFalse(myArrayList.isEmpty());
    }

    @Test
    public void isEmptyTest2(){
        //Given
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        //When

        //Then
        Assert.assertTrue(myArrayList.isEmpty());
    }

    @Test
    public void containsTest(){
        //Given
        MyArrayList<Integer> myArrayList = new MyArrayList<>();
        myArrayList.add(45);
        myArrayList.add(12);
        //When

        //Then
        Assert.assertTrue(myArrayList.contains(12));
    }

    @Test
    public void containsTest2(){
        //Given
        MyArrayList<String> myArrayList = new MyArrayList<>();
        myArrayList.add("Hi");
        myArrayList.add("Mars");
        //When

        //Then
        Assert.assertTrue(myArrayList.contains("Mars"));
    }

    @Test
    public void containsTest3(){
        //Given
        MyArrayList<Object> myArrayList = new MyArrayList<>();
        myArrayList.add(45);
        myArrayList.add("Hi");
        //When

        //Then
        Assert.assertTrue(myArrayList.contains(45));
    }

    @Test
    public void containsTest4(){
        //Given
        MyArrayList<Long> myArrayList = new MyArrayList<>();
        myArrayList.add(45L);
        myArrayList.add(12343L);
        //When

        //Then
        Assert.assertTrue(myArrayList.contains(12343L));
    }

}