import com.sun.deploy.util.ArrayUtil;
import org.junit.Assert;
import org.junit.Test;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;

import static org.junit.Assert.*;

public class MyMapTest {

    @Test
    public void putTest() {
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);

        int expected = 2;

        Assert.assertEquals(expected, testMap.size());
    }

    @Test
    public void putTest2() {
        MyMap<String> testMap = new MyMap<>();
        testMap.put("Hi", "Mars");
        testMap.put("Hello", "Moon");

        int expected = 2;

        Assert.assertEquals(expected, testMap.size());
    }

    @Test
    public void putTest3() {
        MyMap<Object> testMap = new MyMap<>();
        testMap.put(1, "Mars");
        testMap.put(2, "Moon");

        int expected = 2;

        Assert.assertEquals(expected, testMap.size());
    }

    @Test
    public void putTest4() {
        MyMap<Long> testMap = new MyMap<>();
        testMap.put(1L, 45L);
        testMap.put(24L, 65L);

        int expected = 2;

        Assert.assertEquals(expected, testMap.size());
    }


    @Test
    public void removeTest() {
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);
        testMap.remove(2, 65);
        int expected = 1;

        Assert.assertEquals(expected, testMap.size());
    }

    @Test
    public void removeTest2() {
        MyMap<String> testMap = new MyMap<>();
        testMap.put("Hi", "Mars");
        testMap.put("Hello", "Earth");
        testMap.remove("Hi", "Mars");
        int expected = 1;

        Assert.assertEquals(expected, testMap.size());
    }
    @Test
    public void removeTest3() {
        MyMap<Object> testMap = new MyMap<>();
        testMap.put(1, "Hi");
        testMap.put(2, "Mars");
        testMap.remove(2, "Mars");
        int expected = 1;

        Assert.assertEquals(expected, testMap.size());
    }
    @Test
    public void removeTest4() {
        MyMap<Long> testMap = new MyMap<>();
        testMap.put(1L, 45L);
        testMap.put(2L, 65L);
        testMap.remove(2L, 65L);
        int expected = 1;

        Assert.assertEquals(expected, testMap.size());
    }

    @Test
    public void keySetTest() {
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);
        testMap.put(6, 100);
        testMap.put(10, 33);

        Integer[] expected = {1, 2, 6, 10};

        System.out.println(Arrays.toString(testMap.keySet()));

        Assert.assertEquals(expected, testMap.keySet());
    }

    @Test
    public void keySetTest2(){
        MyMap<String> testMap = new MyMap<>();
        testMap.put("hi", "Mars");
        testMap.put("Bye", "Moon");


        String[] expected = {"hi", "Bye"};

        System.out.println(Arrays.toString(testMap.keySet()));

        Assert.assertEquals(expected, testMap.keySet());
    }

    @Test
    public void entrySetTest(){
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);
        testMap.put(6, 100);
        testMap.put(10, 33);

        Integer[] expected = {45, 65, 100, 33};

        System.out.println(Arrays.toString(testMap.entrySet()));

        Assert.assertEquals(expected, testMap.entrySet());
    }

    @Test
    public void entrySetTest2(){
        MyMap<String> testMap = new MyMap<>();
        testMap.put("hi", "Mars");
        testMap.put("Bye", "Moon");


        String[] expected = {"Mars", "Moon"};

        System.out.println(Arrays.toString(testMap.entrySet()));

        Assert.assertEquals(expected, testMap.entrySet());
    }

    @Test
    public void get() {
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);

        int expected = 65;

        Assert.assertEquals(expected, testMap.get(2));
    }

    @Test
    public void size() {
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);
        testMap.put(3, 77);

        int expected = 3;

        Assert.assertEquals(expected, testMap.size());
    }

    @Test
    public void clear() {
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);
        testMap.clear();
        int expected = 0;

        Assert.assertEquals(expected, testMap.size());
    }

    @Test
    public void isEmpty() {
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);
        testMap.clear();

        Assert.assertTrue(testMap.isEmpty());
    }

    @Test
    public void isEmpty2(){
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);

        Assert.assertFalse(testMap.isEmpty());
    }

    @Test
    public void containsValueTest() {
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);

        Assert.assertTrue(testMap.containsValue(65));
    }

    @Test
    public void containsKeyTest(){
        MyMap<Integer> testMap = new MyMap<>();
        testMap.put(1, 45);
        testMap.put(2, 65);

        Assert.assertTrue(testMap.containsKey(2));
    }
}