import org.junit.Assert;
import org.junit.Test;

import java.util.HashSet;
import java.util.Set;

import static org.junit.Assert.*;

public class MySetTest {

    @Test
    public void addTest(){
        //Given
        MySet<Integer> mySet = new MySet<>();
        mySet.add(5);

        //When
        int expected = 1;

        //Then
        Assert.assertEquals(expected, mySet.size());
    }

    @Test
    public void addTest2(){
        //Given
        MySet<String> mySet = new MySet<>();
        mySet.add("Hi");
        mySet.add("Mars");
        mySet.add("Hi");

        //When
        int expected = 2;

        //Then
        Assert.assertEquals(expected, mySet.size());
    }

    @Test
    public void addTest3(){
        //Given
        MySet<Object> mySet = new MySet<>();
        mySet.add(509);
        mySet.add(509);

        //When
        int expected = 1;

        //Then
        Assert.assertEquals(expected, mySet.size());
    }

    @Test
    public void addTest4(){
        //Given
        MySet<Long> mySet = new MySet<>();
        mySet.add(878070L);

        //When
        int expected = 1;
        int actual = mySet.size();

        //Then
        Assert.assertEquals(expected, actual);
    }


    @Test
    public void removeTest(){
        //Given
        MySet<Integer> mySet = new MySet<>();
        mySet.add(5);
        mySet.add(15);
        mySet.add(5);
        mySet.remove(5);
        //When
        int expected = 1;
        int actual = mySet.size();
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void removeTest2(){
        //Given
        MySet<String> mySet = new MySet<>();
        mySet.add("Hi");
        mySet.add("Mars");
        mySet.remove("Mars");
        //When
        int expected = 1;
        int actual = mySet.size();
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void removeTest3(){
        //Given
        MySet<Object> mySet = new MySet<>();
        mySet.add(5);
        mySet.add("Hi");
        mySet.add("Hi");
        mySet.remove(5);
        //When
        int expected = 1;
        int actual = mySet.size();
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest(){
        //Given
        MySet<Integer> mySet = new MySet<>();
        mySet.add(45);
        mySet.add(12);
        mySet.set(0, 6);
        //When
        int expected = 6;
        int actual = mySet.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest2(){
        //Given
        MySet<String> mySet = new MySet<>();
        mySet.add("Hi");
        mySet.add("Mars");
        mySet.set(0, "Bye");
        //When
        String expected = "Bye";
        String actual = mySet.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest3(){
        //Given
        MySet<Object> mySet = new MySet<>();
        mySet.add(45);
        mySet.add("Hi");
        mySet.set(0, 6);
        //When
        Object expected = 6;
        Object actual = mySet.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void setTest4(){
        //Given
        MySet<Long> mySet = new MySet<>();
        mySet.add(45L);
        mySet.add(1200L);
        mySet.set(0, 6L);
        //When
        Long expected = 6L;
        Long actual = mySet.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getTest(){
        //Given
        MySet<Integer> mySet = new MySet<>();
        mySet.add(6);
        mySet.add(12);
        //When
        int expected = 6;
        int actual = mySet.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getTest2(){
        //Given
        MySet<String> mySet = new MySet<>();
        mySet.add("Hi");
        mySet.add("Mars");
        //When
        String expected = "Hi";
        String actual = mySet.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getTest3(){
        //Given
        MySet<Object> mySet = new MySet<>();
        mySet.add(6);
        mySet.add("Hi");
        //When
        Object expected = 6;
        Object actual = mySet.get(0);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void getTest4(){
        //Given
        MySet<Long> mySet = new MySet<>();
        mySet.add(6L);
        mySet.add(1200L);
        //When
        Long expected = 1200L;
        Long actual = mySet.get(1);
        //Then
        Assert.assertEquals(expected, actual);
    }

    @Test
    public void clearTest(){
        //Given
        MySet<Integer> mySet = new MySet<>();
        mySet.add(45);
        mySet.add(12);
        mySet.clear();
        //When

        //Then
        Assert.assertTrue(mySet.isEmpty());
    }

    @Test
    public void isEmptyTest(){
        //Given
        MySet<Integer> mySet = new MySet<>();
        mySet.add(45);
        mySet.add(12);
        //When

        //Then
        Assert.assertFalse(mySet.isEmpty());
    }

    @Test
    public void isEmptyTest2(){
        //Given
        MySet<Integer> mySet = new MySet<>();
        //When

        //Then
        Assert.assertTrue(mySet.isEmpty());
    }

    @Test
    public void containsTest(){
        //Given
        MySet<Integer> mySet = new MySet<>();
        mySet.add(45);
        mySet.add(12);
        //When

        //Then
        Assert.assertTrue(mySet.contains(12));
    }

    @Test
    public void containsTest2(){
        //Given
        MySet<String> mySet = new MySet<>();
        mySet.add("Hi");
        mySet.add("Mars");
        //When

        //Then
        Assert.assertTrue(mySet.contains("Mars"));
    }

    @Test
    public void containsTest3(){
        //Given
        MySet<Object> mySet = new MySet<>();
        mySet.add(45);
        mySet.add("Hi");
        //When

        //Then
        Assert.assertTrue(mySet.contains(45));
    }

    @Test
    public void containsTest4(){
        //Given
        MySet<Long> mySet = new MySet<>();
        mySet.add(45L);
        mySet.add(12343L);
        //When

        //Then
        Assert.assertTrue(mySet.contains(12343L));
    }
}